'' Driving Sim



CON
  '' Uncomment section for your configuration type:

'' Demoboard/Protoboard/SpinStudio Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
   video     = 12 '' I/O for composite video connection

{
'' Hydra Boards
   _clkmode  = xtal1 + pll8x
   _xinfreq  = 10_000_000
    video     = 24 '' I/O for composite video connection 
}   

{
'' Hybrid Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
    video     = 24 '' I/O for composite video connection 
}
  ' NES bit encodings for NES gamepad 0
  NES0_RIGHT    = %00000000_00000001
  NES0_LEFT     = %00000000_00000010
  NES0_DOWN     = %00000000_00000100
  NES0_UP       = %00000000_00001000
  NES0_START    = %00000000_00010000
  NES0_SELECT   = %00000000_00100000
  NES0_B        = %00000000_01000000
  NES0_A        = %00000000_10000000  
  
  '' joypad serial shifter settings
  JOY_CLK = 3
  JOY_LCH = 4
  JOY_DATAOUT0 = 5
  JOY_DATAOUT1 = 6

  BLACK             = $02 
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3 
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03 
  LGREEN            = $1C
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGREY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1 
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

  CR                = $0D
  LF                = $0A
  TAB               = $09
  BKS               = $08
   
OBJ
     text  : "aigeneric_driver_acs"

VAR
     word  Nes_Pad     
     
PUB mainProgram   |  character_x, character_y, character_chr, character_step
  text.start(video)
  character_x := 5
  character_y := 5
  character_step := 0
  character_chr := 41
          
  graphics
  DrawBackground
  DrawCharacter (character_x, character_y, character_chr)
  'this method tells the object to move what is in the buffer to the display 
  '*note* -- do this as the last step in the display
  text.UpdateScreen

  repeat
    text.cls
    DrawBackground


{
    Nes_Pad := NES_Read_Gamepad

    if(Nes_Pad & NES0_RIGHT)
        character_y++
        if (character_step == 0)
           character_chr := 40
        else
           character_chr := 46
     
    if(Nes_Pad & NES0_LEFT)
        character_y--
        if (character_step == 0)
           character_chr := 41
        else
           character_chr := 44

    DrawCharacter (character_x, character_y, character_chr)
    character_step++
    if (character_step > 1)
        character_step := 0
     
    '*note* -- do this as the last step in the display
}

    text.UpdateScreen

  
PUB  DrawBackground  | i
   text.color(red)
   text.str(string("Need to place data from street here."))
   text.out(13)


   

PUB DrawCharacter (character_x, character_y, character_chr) 
     text.pokechar(character_x, character_y, white, character_chr) 
   
PUB graphics
  text.redefine(35,253,253,253,0,191,191,191,0)      '' bricks
  text.redefine(40,120,120,31,52,110,110,231,3)      '' player running left 1
  text.redefine(46,120,120,31,112,108,111,96,96)     '' player running left 2
  text.redefine(41,30,30,248,28,118,118,231,224)     '' player running right 1
  text.redefine(44,31,31,64,28,102,246,10,10)        '' player running right 2


  
PUB NES_Read_Gamepad : nes_bits        |  i
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]
'
' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5) 
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding
'
' RIGHT  = %00000001
' LEFT   = %00000010
' DOWN   = %00000100
' UP     = %00001000
' START  = %00010000
' SELECT = %00100000
' B      = %01000000
' A      = %10000000

' step 1: set I/Os
DIRA [JOY_CLK] := 1 ' output
DIRA [JOY_LCH] := 1 ' output
DIRA [JOY_DATAOUT0] := 0 ' input
DIRA [JOY_DATAOUT1] := 0 ' input

' step 2: set clock and latch to 0
OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [JOY_LCH] := 1 ' JOY_SH/LDn = 1
'Delay(1)                            

' step 4: set latch to 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0

' data is now ready to shift out, clear storage
nes_bits := 0

' step 5: read 8 bits, 1st bits are already latched and ready, simply save and clock remaining bits
repeat i from 0 to 7

 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[JOY_DATAOUT0] | (INA[JOY_DATAOUT1] << 8)

 OUTA [JOY_CLK] := 1 ' JOY_CLK = 1
 'Delay(1)             
 OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
 
 'Delay(1)             
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       

' ////////////////////////////////////////////////////////////////////

DAT
street byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0

snow
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
       byte " ...\                              /...",0
